#!/usr/bin/python
from distutils.core import setup
from glob import glob
import sys

if sys.hexversion < 0x020400f0:
    sys.stderr.write("python version failed: current version = %s.%s, needed version >= 2.4\n" % (sys.version_info[0],sys.version_info[1]))
    sys.exit(1)
try:
    import libxml2
except ImportError:
    sys.stderr.write("dependencies failed: python libxml2\n") 
    sys.exit(1)
try:
    import libxslt
except ImportError:
    sys.stderr.write("dependencies failed: python libxslt1\n") 
    sys.exit(1)
try:
    import gtk.glade
except ImportError:
    sys.stderr.write("dependencies failed: python glade\n") 
    sys.exit(1)



setup(name='loemu',
      version='0.1.1',
      description='A PyGTK frontend for game emulators',
      author='Bernat Pegueroles Forcadell',
      author_email='bernat@pegueroles.cat',
      url='http://pegueroles.cat/loemu',
      long_description="""A PyGTK frontend for game emulators.
Features:
 * Supports game emulation with xmame, sdlmame and snes9x.
 * Browse games using dynamic list. This allows to browse in a list 
   generated with some categories (and it has other advantages).
 * Finds games quickly. Using a specific dialog that looks for a
   game in all the gamelist.
 * The generation of subsets of the gamelist is very fast.
""",
      license='GNU GPL',
      platforms='linux',
      packages=['loemu'],
      scripts=glob("scripts/*"),
      data_files=[
                  ('share/games/loemu/config',glob("config/*")),
                  ('share/games/loemu/glade',glob("glade/*")),
                  ('share/games/loemu/roms',''),
                  ('share/games/loemu/flyers',''),
                  ('share/games/loemu/snaps',''),
                  ]
      )
